#!/usr/bin/env python

def read_file(name):
	res = []
	f = open(name).readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def print_match(bits, nums):

	#for n in nums:
	#	tot += n
	
	avg = 0 # tot / 128.
	num_ok = 0
	lim = 0
	for b, n in zip(bits, nums):
		if b:
			if n > avg + lim:
				num_ok += 1
		else:
			if n < avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def read_res_file():
	res = []
	f = open("row.0.txt").readlines()
	for l in f[:32]:
		l = l.strip().split('   ')
		res += l

	tot = 0.0
	nums = []
	bits = []

	for l in res:
		l = l.strip().split(" ")
		#print l
		n = float(l[3])
		#b = int(l[3][:1])
		#if not b:
		#	n = -n
		#print l[0], n
		tot += n
		nums.append(n)
		bits.append(l[1])
	
	avg = tot / 128.
	num_ok = 0
	lim = 0.0255
	for b, n in zip(bits, nums):
		if b:
			if n < avg + lim:
				num_ok += 1
		else:
			if n > avg + lim:
				num_ok += 1
		print b, n, n-avg
	print avg, num_ok

def read_results_file(name):
	res = []
	key = []
	f = open(name).readlines()
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		res.append(float(l[1]))
		key.append(int(l[3][:1]))
	return res, key

def test1(name):
	res = []
	f = open(name).readlines()
	for l in f[:128]:
		l = l.strip().split(" ")
		#print l
		n = float(l[1])
		b = int(l[3][:1])
		if not b:
			n = -n
		print l[0], n

if __name__ == '__main__':
	kr = {}
	kc = {}

	for rotate_x in [0, 8]:
		kr[rotate_x] = {}
		kc[rotate_x] = {}
		for rotate_y in [0, 8]:
			kr[rotate_x][rotate_y] = {}
			kc[rotate_x][rotate_y] = {}

	tr = [0.0] * 128
	tc = [0.0] * 128
	ar = [1] * 128
	ac = [1] * 128

	for r in range(0, 128, 16):

		for rotate_x in [0, 8]:
			for rotate_y in [0, 8]:
				res, key = read_results_file("row.%d.%dx%d.txt" % \
				                      (r, rotate_x, rotate_y))
				kr[rotate_x][rotate_y][r] = res
				tr = map(lambda (x,y): x+y, zip(tr, res))

				res, key = read_results_file("col.%d.%dx%d.txt" % \
				                      (r, rotate_x, rotate_y))
				kc[rotate_x][rotate_y][r] = res
				tc = map(lambda (x,y): x+y, zip(tc, res))
	
	for r in range(0, 128, 16):
		for rotate_x in [0, 8]:
			for rotate_y in [0, 8]:
				for i in range(128):
					if kc[rotate_x][rotate_y][r][i] < 0:
						if key[i] == 0:
							ac[i] = 0
					if kc[rotate_x][rotate_y][r][i] > 0:
						if key[i] == 1:
							ac[i] = 0
			
					if kr[rotate_x][rotate_y][r][i] < 0:
						if key[i] == 0:
							ar[i] = 0
					if kr[rotate_x][rotate_y][r][i] > 0:
						if key[i] == 1:
							ar[i] = 0
			
	print ar
	print ac
	arc = map(lambda (x,y): x==y, zip(ar, ac))
	print "ar=ac", arc
	print key
	print_match(key, tr)
	print
	print_match(key, tc)
	tt = map(lambda (x,y): x+y, zip(tc, tr))
	print
	print_match(key, tt)
	#print_match(key, kc[16])

